import { CdkConnectedOverlay, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { Subject } from 'rxjs/Subject';
import { Subscription } from 'rxjs/Subscription';
export declare type NzPlacement = 'bottomLeft' | 'bottomCenter' | 'bottomRight' | 'topLeft' | 'topCenter' | 'topRight';
export declare class NzDropDownComponent implements OnInit, OnDestroy, AfterViewInit {
    private _renderer;
    protected _changeDetector: ChangeDetectorRef;
    private _clickHide;
    private _visible;
    hasFilterButton: boolean;
    _triggerWidth: number;
    _placement: NzPlacement;
    _dropDownPosition: 'top' | 'center' | 'bottom';
    _positions: ConnectionPositionPair[];
    _subscription: Subscription;
    _nzOrigin: any;
    _nzMenu: any;
    nzTrigger: 'click' | 'hover';
    _visibleChange: Subject<boolean>;
    nzVisibleChange: EventEmitter<boolean>;
    _cdkOverlay: CdkConnectedOverlay;
    nzClickHide: boolean;
    nzVisible: boolean;
    nzPlacement: NzPlacement;
    _onClickEvent(): void;
    _onMouseEnterEvent(e: MouseEvent): void;
    _onMouseLeaveEvent(e: MouseEvent): void;
    _hide(): void;
    _show(): void;
    _onPositionChange(position: ConnectedOverlayPositionChange): void;
    _clickDropDown($event: MouseEvent): void;
    _setTriggerWidth(): void;
    _onVisibleChange: (visible: boolean) => void;
    _startSubscribe(observable$: Observable<boolean>): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    readonly _hasBackdrop: boolean;
    constructor(_renderer: Renderer2, _changeDetector: ChangeDetectorRef);
}
