import { AfterViewInit, ComponentFactory, ElementRef, EventEmitter, OnDestroy, OnInit, TemplateRef, ViewContainerRef } from '@angular/core';
import { NzLocaleService } from '../locale/index';
import { NzModalSubject } from './nz-modal-subject.service';
export declare class NzModalComponent implements OnInit, OnDestroy, AfterViewInit {
    subject: NzModalSubject;
    private _vcr;
    private _locale;
    private _confirmLoading;
    private _maskClosable;
    _footerHide: boolean;
    _closable: boolean;
    _visible: boolean;
    _prefixCls: string;
    _maskClassMap: any;
    _bodyClassMap: any;
    _bodyStyleMap: any;
    _width: string;
    _zIndex: number;
    _title: string;
    _titleTpl: TemplateRef<void>;
    _content: string;
    _contentTpl: TemplateRef<void>;
    _footerTpl: TemplateRef<void>;
    _okText: string;
    _cancelText: string;
    _style: object;
    _wrapClass: string;
    _customClass: string;
    _animationStatus: string;
    _bodyComponent: ComponentFactory<void>;
    _componentParams: object;
    modalId: string;
    contentEl: ElementRef;
    bodyEl: ViewContainerRef;
    nzVisible: boolean;
    nzConfirmLoading: boolean;
    nzClosable: boolean;
    nzClass: string;
    nzWidth: string | number;
    nzZIndex: number;
    nzTitle: string | TemplateRef<void>;
    nzContent: string | TemplateRef<void> | ComponentFactory<void>;
    nzFooter: TemplateRef<void> | boolean;
    nzOkText: string;
    nzCancelText: string;
    nzMaskClosable: boolean;
    nzStyle: object;
    nzWrapClassName: string;
    nzComponentParams: object;
    nzVisibleChange: EventEmitter<boolean>;
    nzOnOk: EventEmitter<MouseEvent>;
    nzOnCancel: EventEmitter<MouseEvent | KeyboardEvent>;
    onEsc(e: KeyboardEvent): void;
    setStyles(origin?: {
        x: number;
        y: number;
    }): void;
    setClassMap(): void;
    anmiateFade(status: string): void;
    closeFromMask(e: MouseEvent): void;
    setConfirmLoading(loading: boolean): void;
    open(): void;
    close(): void;
    clickOk(e: MouseEvent): void;
    clickCancel(e: MouseEvent | KeyboardEvent): void;
    constructor(subject: NzModalSubject, _vcr: ViewContainerRef, _locale: NzLocaleService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
